<script lang="ts">
	import { onDestroy, onMount } from 'svelte';
	import { ws } from '$lib/config';
	import { page } from '$app/stores';
	import { type Team, teams } from '$lib/teams';
	import { quintOut } from 'svelte/easing';
	import { slide } from 'svelte/transition';
	import ReconnectingWebSocket from 'reconnecting-websocket';

	const teamId = $page.url.searchParams.get('team');
	const team: Team | null = teamId ? teams[+teamId] : null;

	let displayedObj: string | null;

	let fifo: string[] = [];
	let fifoRunning: number | null;

	let width: number;
	let test: HTMLDivElement;

	let timeout: number = 0;

	// Quand tu recois un message tu le append dans fifo :
	function receiveDon(message: string) {
		fifo.push(message);
		runFifo();
	}

	function runFifo() {
		if (fifoRunning) return;
		fifoRunning = setInterval(doSomething, 100);
	}

	function doSomething() {
		// Ce que tu dois faire avec le dernier
		if (!timeout) {
			let don = fifo.shift();
			if (don) {
				displayedObj = don;
				setTimeout(() => {
					let box = document.getElementById('news-item-id');
					width = box?.getBoundingClientRect()?.width || 0;
					let duration = 0.02 * (width + window.innerWidth);
					test.style.transition = `all ${duration}s linear`;
					test.style.transform = `translateX(${-width}px) `;
					if (timeout) {
						clearTimeout(timeout);
						timeout = 0;
					}
					timeout = setTimeout(() => {
						displayedObj = null;
						timeout = 0;
					}, duration * 1000);
				}, 2);
			}

			if (fifo.length === 0 && fifoRunning) {
				clearInterval(fifoRunning);
				fifoRunning = null;
			}
		}
	}

	onMount(async () => {
		// Start WS
		const socket = new ReconnectingWebSocket(ws());

		socket.addEventListener('open', function (event) {
			socket.send(JSON.stringify({ op: 'sub', msg: `teams.${teamId}.message` }));
		});

		socket.addEventListener('message', function (event) {
			let data = JSON.parse(event.data);

			switch (data.r) {
				case `teams.${teamId}.message`:
					receiveDon(data.d.message);
					break;
				case `refresh`:
					// Refresh the page
					setTimeout(() => {
						window.location.reload();
					}, Math.random() * 1000);
					break;
			}
		});
	});

	onDestroy(() => {
		if (fifoRunning) {
			clearInterval(fifoRunning);
		}
	});
</script>

<div class="flex flex-col items-center font-extrabold -mt-20">
	{#if displayedObj}
		<div
			in:slide={{ delay: 350, duration: 300, easing: quintOut, axis: 'y' }}
			out:slide={{ delay: 150, duration: 300, easing: quintOut, axis: 'y' }}
			class="team-title team-name text-3xl"
			style:color={team?.color}
		>
			{team?.name}
		</div>
		<div
			in:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
			out:slide={{ delay: 250, duration: 300, easing: quintOut, axis: 'y' }}
			class="news-container mt-20"
		>
			<div class="news-title flex item-center text-3xl">Alerte !</div>
			<div
				id="news-text-id"
				class="news-text text-xl font-extrabold"
				style="background-color:transparent"
				bind:this={test}
			>
				<div class="news-item">
					{displayedObj}
				</div>
			</div>
		</div>
	{/if}
	<div id="news-item-id" class="text-xl" style:opacity={0}>
		{displayedObj}
	</div>
</div>

<style>
	:global(body) {
		overflow: hidden;
	}
	.team-name {
		-webkit-text-stroke-width: 1px;
		-webkit-text-stroke-color: black;
	}
	.team-title {
		position: absolute;
		bottom: 0;
		left: 0;
		padding: 0 5px 32px 0;
		font-style: italic;
		color: white;
	}
	.news-container {
		position: fixed;
		bottom: 0;
		left: 0;
		right: 0;
		box-shadow: 0 -4px 8px -4px black;
		background: #141414;
		background: linear-gradient(to top left, #141414 0%, #242424 100%);
	}
	.news-title {
		position: absolute;
		background: #630000;
		background: linear-gradient(to bottom right, #630000 0%, #e81814 100%);
		height: 100%;
		padding: 0 20px;
		font-style: italic;
		color: white;
		z-index: 10;
	}

	.news-text {
		padding: 5px 0;
		display: flex;
		transform: translateX(100%);
	}
	.news-item {
		color: #ddd;
		white-space: nowrap;
	}
	#news-item-id {
		white-space: nowrap;
	}
</style>
